# include <stdlib.h>

# include "main.h"


char *Convert_path(char *normurl,int cmd)
{
 char tmp[STRING_SIZE],tmp_path[STRING_SIZE];
 char *ret;
 register char *p,*q;
 int no_doubleslash=1,slash_count=0;

 p = normurl;
 q = tmp_path;

 while(*(p+1) && (*p != '\r') && (*p != '\n'))
 {
  if(*p == ':')
  {
   if(*(p+1) == '/')
   {
    p += 2;
    slash_count++;
    no_doubleslash = 0;
   }
   else
   {
    *q++ = '/';
    p++;
    continue;
   }
  }
  else if(*p == '/')
  {
   slash_count++;
  }
  *q++ = *p++;
 }
 *q = 0;
 if(*p == '/')
	sprintf(tmp,"%s/%s/%s",pool_dir,tmp_path,PADDING_NAME);
 else
 {
  *q++=*p++;
  *q=0;
  if((slash_count > 1) || no_doubleslash)
	sprintf(tmp,"%s/%s",pool_dir,tmp_path);
  else
	sprintf(tmp,"%s/%s/%s",pool_dir,tmp_path,PADDING_NAME);
 }

 /*	sizeof(ret)=strlen(tmp) + strlen(ext) + strlen('\0')	*/

 ret = (char *)malloc((sizeof(char))*(strlen(tmp)+9+1));
 strcpy(ret,tmp);
 
 switch(cmd)
 {
  case INFO_FILE:
			strcat(ret,INFO_EXT);
			break;

  case LOCK_FILE:
			strcat(ret,LOCK_EXT);
			break;

  case HEAD_FILE:
			strcat(ret,HEAD_EXT);
			break;
/*
  case HEAD_TMP_FILE:
			strcat(ret,HEAD_TMP_EXT);
			break;

  case BODY_TMP_FILE:
			strcat(ret,BODY_TMP_EXT);
			break;
*/
 }
// Trace("Convert_path:\n\n\t\t\t%s\n\t\t\t\t\tinto\n\t\t%s\n",normurl,ret);
 return ret;
}

int Create_path(char *path)
{
 char tmp[STRING_SIZE];
 struct stat sbuf;
 int ret=0;
 register char *p;

// Trace("Create_Path:\n\t\t\tTarget Path is %s",path);
 
 p = tmp;
 
 while(1)
 {
  *p++ = *path++;
  while(*path && (*path != '/'))
	*p++ = *path++;
  *p = 0;
  
//  Trace("Create_path:\n\t\t\tChecking %s",tmp);

  if(*path)	/*	path is a directory	*/
   	if(not_found(tmp,&sbuf))
	{
	 if(mkdir(tmp,0755))	/*    tmp directory not found	*/
	 {
	  Error("Create_path: Cannot create directory %s",tmp);
	  ret = 1;
	  break;
	 }
    	}
	else	/*	tmp directory found	*/
	{
      	 if(sbuf.st_mode & S_IFDIR)
	 	continue;
	}
  else		/*	path is not directory	*/
	break;
 }
 return ret;
}

int not_found(char *name,struct stat *sbuf)
{
 return(stat(name,sbuf));
}

int Have(char *normurl)
{
 Info tmp;
 int fd,ret,c;
 time_t now;
 char *fname;

 fname = Convert_path(normurl,INFO_FILE);
 
 if((fd = open(fname,O_RDONLY)) < 0)
 {
  Trace("Have: Cannot open %s. %s does not exist.",fname, normurl);
  ret = 0;
 }
 else
 {
  time(&now);
  if(c = read(fd,&tmp,sizeof(Info)))
  {
 //  if(tmp.attr.expiry<now)
   if(tmp.expiry_time <= difftime(now, tmp.created_time))
   {
    Trace("Have: %s is expired.",normurl);
    ret = 0;
   }
   else
   {
    Trace("Have: Unexpired %s exists in cache.",normurl);
    ret = 1;
   }
  }
  else
  {
   Error("Have: Empty %s",fname);
   ret = 0;
  }
  close(fd);
 }  
 return ret;
}
int Post_HTTP(char *normurl,int client_sd,char *post_buf,int buf_len)
{
 char head[BUF_SIZE+2],buf[BUF_SIZE];
 int rcount,rtime,pos,sock_fd;  
 int in_head; 
 int server_status;
 char servername[STRING_SIZE],protocol[STRING_SIZE],port[STRING_SIZE],path[STRING_SIZE];
 int chk = ParseURL(normurl,protocol,servername,port,path);
  
 Trace("Post_HTTP:\n\t\tHTTP Server = %s Port = %d Path =
%s",servername,port,path);
 if((sock_fd=connectServer(servername,(unsigned)atoi(port)))<0)
 {
  Error("Post_HTTP:\n\t\tCannot connect to server %s on port
%d",servername,port);
  return 0;
 }
 sprintf(buf,
 "POST %s HTTP/1.0\r\nUser-Agent: %s\r\nAccept: */*\r\nContent-Length:%d\r\n%s\r\n%s",path,"SBVC PROXY",buf_len,Authorization_Line,post_buf);
rcount = write(sock_fd,buf,sizeof(char)*strlen(buf));
 shutdown(sock_fd,1);
 Trace("Post_HTTP:\n\t\tSent Request\nrcount = %d,strlen(buf) =
%d\n%s",rcount,strlen(buf),buf);
 memset(head,0,sizeof(char)*(BUF_SIZE+2));
 rtime = 0;
 in_head = 1;

 while(in_head && (rcount = read(sock_fd,head,BUF_SIZE))>0)
 {
  pos = 0;
  if(rtime==0)
  {
   server_status = atoi(&head[9]);
   Trace("Post_HTTP:\n\t\tServer reply status = %d.\n",server_status);
   if(server_status == 401)
   	        Trace("Post_HTTP:\n\t\tAuthorization Request");
   else if(server_status == 200)
		   	Trace("Post_HTTP:\n\t\tSee rfc");
   else if(server_status == 201)
		Trace("Post_HTTP:\n\t\tNew URI has been succesfully created");
   else if(server_status == 204)
		Trace("Post_HTTP:\n\t\tNo Content");
   else if(server_status == 202)
		Trace("Post_HTTP:\n\t\tWait for connection being processed");
   else if(server_status<200 && server_status>400)
   { 
    Error("Post_HTTP:\n\t\tIgnore reply status %d and reject",server_status);
    return 0;
   }
  }
  while(pos<=rcount && !(head[pos]=='\n' && head[pos+1]=='\n') 
            && !(head[pos]=='\n' && head[pos+1]=='\r' && head[pos+2]=='\n')) 
            pos++;
  Trace("Post_HTTP: HEAD %d bytes in %d bytes.",pos,rcount);
  if(pos<=rcount)
  { 
   if(head[pos+1]=='\r') 
   	pos+=3;				/* Skip 3chars (\n \r \n) */ 
   else 
   	pos+=2;				/* Skip 2chars (\n \n)    */ 
 	 
   Trace("Post_HTTP:\n\t\tFound separator at %d of %d bytes.",pos,rcount); 
			 
   write(client_sd,head,pos);          		/* write head */ 
   write(client_sd,&head[pos],rcount-pos); 	/* write rest, so its body */ 
   head[pos] = '\0';                 		/* truncate head */ 
 
   Trace("Post_HTTP:\n\t\tHEAD %d,BODY %d in %d.",pos,rcount - pos,rcount);
   in_head = 0; 
  }
  else
  {
   write(client_sd, head, rcount);	/* write head */
   head[0] = '\0';			/* clear head */
   
   Trace("Post_HTTP:\n\t\tHEAD %d bytes.", rcount);
  }
  rtime ++;  
 }
 /* 
  * Loop for BODY writing 
  */ 
 while((rcount=read(sock_fd,buf,BUF_SIZE))>0)
 	if(write(client_sd,buf,rcount)!=rcount)
  		Error("Post_HTTP:\n\t\tCannot write reading %s",servername); 
 shutdown(client_sd,2);
 close(client_sd);
} 

int Send_Head_Direct(char *normurl,int client_sd) 
{ 
 char *hpath; 
 char buf[BUF_SIZE]; 
 int head_fd; 
 int sum,c; 
 
 
 hpath = Convert_path(normurl,HEAD_FILE); 
 if((head_fd=open(hpath,O_RDONLY))<0)
 { 
  free(hpath); 
  return 0; 
 } 
 
 Trace("Send_Head_Direct: Sending %s",normurl); 
 sum = 0; 
 while((c=read(head_fd,buf,BUF_SIZE))>0)
 { 
  write(client_sd,buf,c); 
  sum += c; 
 } 
 close(head_fd); 
 
 //Trace("Send_Head_Direct:\n\t\t%d bytes.",sum); 
 
 free(hpath); 
 return 1; 
} 
int Send_Page_From_Cache(char *normurl,int client_sd) 
{ 
 char buf[BUF_SIZE]; 
 int c,sum; 
 char *path; 
 int fd; 
 
 //Trace("Send_Page_From_Cache:\n\t\tname=%s",normurl); 
 /* 
  * Head Transfer 
  */ 
 if(Send_Head_Direct(normurl,client_sd))
 	;//Trace("Send_Page_From_Cache:\n\t\tHead sent succesfully");
 else
 {
  Error("Send_Page_From_Cache:\n\t\tSend_Head_Direct unsuccesful");
  return 0;
 }
 path = Convert_path(normurl,BODY_FILE); 
 if((fd=open(path,O_RDONLY))<0)
 { 
  Error("Send_Page_From_Cache:\n\t\tCannot open file %s",path); 
  free(path); 
  return 0; 
 } 

 sum = 0; 
 while((c=read(fd,buf,sizeof(buf)))>0)
 { 
  write(client_sd,buf,c); 
  sum += c; 
 } 
 close(fd); 
 
 shutdown(client_sd,1); 
 close(client_sd); 
 
// Trace("Send_Page_From_Cache:\n\t\tBODY %d bytes",sum); 
 
 free(path); 
 return 1; 
}    
/*int main(void)
{
 char *test,*hname,ch;
 char *name="http://localhost:80/shr/testbase.html";
 char head[3*STRING_SIZE];
 Info info;
 int fd,c=0;
 
 strcpy(pool_dir,DEFAULT_CACHE_DIR);
 hname=Convert_path(name,HEAD_FILE);
 if((fd=open(hname,O_RDONLY)) < 0)
   exit(0);
 while(read(fd,&ch,1))
	 head[c++] = ch;
 head[c]=0;
 printf("%s",head);
 Generate_Info(&info,name,1,2,3,4,1,head);
 test = Convert_path(name,INFO_FILE);
 Create_path(test);
 if((fd=open(test,O_WRONLY))<0)
	exit(0);
 write(fd,&info,sizeof(info));
 Have(name);
}*/
