#include "main.h"

#ifndef BUF_SIZE
#define BUF_SIZE 4096
#endif
#define LIST_TIMEOUT 2
/*
char gp[10] = "21";
char gph[100] = "/";

int parseUrl(const char *normUrl, char *proto, char *server, char *port, char *path) {
	strcpy(server,"balu.com");
	strcpy(port,gp);
	strcpy(path,gph);
	return 1;
}
*/
int processResponse(int netd, int *pret, char *buf, char *pos, int *len) {
	int ret;

	*pret = -1;	
	if(pos != NULL) {
		while(pos - buf <= *len) {
			if(*pos == '\n' || *pos == '\r' || *pos == '\n') {
				pos++;
				break;
			}	
			pos++;
		}
		while(pos - buf <= *len && isspace(*pos))  //skip WS
			pos++;
		if(pos - buf > *len)
			pos = NULL;		
	}

	if(pos == NULL) {
		if((*len = recv(netd, buf, BUF_SIZE, 0)) == -1) 
			return -1;
		pos = buf;
		
		while(pos - buf <= *len && isspace(*pos)) //skip WS
			pos++;
	}
					
	ret = *pos - '0';	//first digit

	if(ret < 1 || ret > 5) 
		return -1;
	else
		*pret = ret;

	if(pos - buf > BUF_SIZE)
		pos = NULL;

	if(ret < 2)
		return 0;
	else if(ret > 2)
		return 0;
	else
		return 1;
}

FILE * getList(int dpd, unsigned long *dataLen) {

	int l;
    FILE *fp;
	char *dp;

	if((dp = (char *)malloc(BUF_SIZE)) == NULL) {
		Error("Not enough memory");
		return NULL;
	}
	
	if((fp = tmpfile()) == NULL) {
		Error("getList: unable to create tmp file");
		free(dp);
		return NULL;
	}
	
	*dataLen = 0;	
	while((l = recv(dpd, dp, BUF_SIZE, 0)) != 0) {
		*dataLen = *dataLen + l;

		if(fwrite(dp, 1, l, fp) != l) {
			Error("Unable to write to tmp file");
			free(dp);
			return NULL;
		}				
	}

	if(l == -1) {
		free(dp);
		return NULL;
	}

	free(dp);
	return fp;
}

int sendList(int client_sd, FILE *fp, unsigned long dataLen) {
	char *dp;	
	int l;
	
	if((dp = (char *)malloc(BUF_SIZE)) == NULL) {
		Error("Not enough memory");
		return -1;
	}
		
	rewind(fp);

	while(1) {
		l = fread(dp, 1, BUF_SIZE, fp);
		if(send(client_sd, dp, l, 0) == -1)
			return -1;
		if(l < BUF_SIZE)
			break;		
	}
	if(send(client_sd, dp, l, 0) == -1)
		return -1;
	return 1;	
}


int processGet(int client_sd, unsigned long dataLen) {
	char head[] = "HTTP/1.0 200 OK\r\nContent-Length: %lu\r\nContent-Type: %s\r\n\r\n";
	char s[1024];

	sprintf(s, head, dataLen, "text/plain");
	if(send(client_sd, s, strlen(s), 0) == -1)
		return -1;	
	return 1;	
}

int parseList(FILE *fp, FILE *tmpfp, unsigned long dataLen, char *path) {
	//fwrite(dp, 1, dataLen, fp);
	int i;
	int p;
	char *q;
	char dir;
	char file[STRING_SIZE];
	
	rewind(tmpfp);
	p = fgetc(tmpfp);
	while(dataLen && p != '\n' && p != '\r') { 
		dataLen--; 
		p = fgetc(tmpfp);
	}
	
	if(p == '\n') { dataLen--;	p = fgetc(tmpfp); }	
	if(p == '\r') { dataLen--;  p = fgetc(tmpfp); }

	while(dataLen > 0) {
		if(p == 'd') dir = '/';
		else	dir = '\0';
		for(i = 1; i <= 8; i++) {	//skip 8 fields
			while(dataLen && p != ' ' && p != '\t') {
				dataLen--;
				p = fgetc(tmpfp);
			}
			
			while(dataLen && (p == ' ' || p == '\t')) {
				dataLen--;
				p = fgetc(tmpfp); 
			}
		}
		//copy file name
		q = file;
		while(dataLen && !isspace(p)) {
			dataLen--;
			*q++ = p;
			p = fgetc(tmpfp); 
		}
		if(dir)
			*q++ = dir;
		*q = 0;

		fprintf(fp, "    <A HREF=\"%s%s\">%s</A><P>", path, file, file);		
	
		//move to next line
		while(dataLen && p != '\n' && p != '\r') { 
			dataLen--;	
			p = fgetc(tmpfp); 
		}	
		
		if(p == '\n') { dataLen--;	p = fgetc(tmpfp); }	
		if(p == '\r') { dataLen--;	p = fgetc(tmpfp); }
	}//while(dataLen>0)	
}

int processList(int client_sd, FILE *tmpfp, unsigned long dataLen, char *path) {
	unsigned i;
	FILE *fp;
	char buf[BUF_SIZE], *p;
	char head[] = "HTTP/1.0 200 OK\r\nContent-Length: %lu\r\nContent-Type: %s\r\n\r\n";
	char s[1024];
	time_t t;


	if((fp = tmpfile()) == NULL) {
//	if((fp = fopen("temp", "w+")) == NULL) {
		Error("processList: unable to create tmp file");
		return 0;
	}

	if(path[strlen(path) - 1] != '/') {
		path[strlen(path)+1] = 0;
		path[strlen(path)] = '/';
	}

	fprintf(fp, "<HTML><HEAD><TITLE>\n");
	fprintf(fp, "FTP Directory: %s </TITLE>\n<HEAD><BODY>", path);
	fprintf(fp, "<H2>Current Directory: %s\n</H2>\n<P>", path);
	fprintf(fp, (strlen(path) != 1)?
				"<A HREF=\"../\">Parent Directory</a>":"Root Directory");
	fprintf(fp, "<P><PRE><H5>");
		
	parseList(fp, tmpfp, dataLen, path);	

	time(&t);
	fprintf(fp, "\n</H5><HR><I><B>Generated by %s -- %s</BODY></HTML>",
					AGENT_INFO, ctime(&t));	
	
	fseek(fp, 0L, SEEK_END);
	sprintf(s, head, ftell(fp), "text/html");
	if(send(client_sd, s, strlen(s), 0) == -1)
		return -1;	
	
	fseek(fp, 0L, SEEK_SET);
	do {
		i = fread(buf, 1, BUF_SIZE, fp);
		if(send(client_sd, buf, i, 0) == -1)
			return -1;
	} while(i == BUF_SIZE);

	fclose(fp);
	return 1;	
}


int listFtp(int client_sd, int netd, int dpd, char *path) {
	
	int len, ret;
    FILE *tmpfp;
	unsigned long dataLen;
	char buf[BUF_SIZE], *pos, *dp;

		
	Trace("List Ftp:%s", path);
	
	if(send(netd, "LIST\n", 5, 0) == -1)
		return -1;	
	pos = NULL;
	if(processResponse(netd, &ret, buf, pos, &len) == 0 && ret == 1) {
		if((tmpfp = getList(dpd, &dataLen)) == NULL)
			return -1;
		shutdown(dpd, 2);	
		close(dpd);
		pos = NULL;
		if(processResponse(netd, &ret, buf, pos, &len) != 1)
			return -1;	
		processList(client_sd, tmpfp, dataLen, path);
		return 1;
	}
	else 
		return -1;
}


int getFtp(char *path, int client_sd, int netd, int dpd) {
	
	int len, ret;
	FILE *tmpfp;
	unsigned long dataLen;
	char buf[BUF_SIZE], cmd[STRING_SIZE], *pos;

	Trace("Get Ftp: %s", path);
	
	sprintf(cmd, "RETR %s\n", path);	
	if(send(netd, cmd, strlen(cmd), 0) == -1)
		return -1;	
	pos = NULL;
	if(processResponse(netd, &ret, buf, pos, &len) == 0 && ret == 1) {
		if((tmpfp = getList(dpd, &dataLen)) == NULL)
			return -1;
		shutdown(dpd, 2);	
		close(dpd);
		pos = NULL;
		if(processResponse(netd, &ret, buf, pos, &len) != 1)
			return -1;	
	
		processGet(client_sd, dataLen);

		sendList(client_sd, tmpfp, dataLen);
		return 1;
	}
	else
		return -1;
}

int initPassive(char *buf, int len) {
	char ip[STRING_SIZE], port1[STRING_SIZE], port2[STRING_SIZE];
	char *p, *q;
	int i, dpd;
	unsigned port;
	struct sockaddr_in addr;
	
	buf[len] = '\0';
	*(strchr(buf, '\n')) = '\0';
	p = strchr(buf, '(');
	q = strchr(buf, ')');
	
	if(p == NULL || q == NULL || q - p < 0)
		return -1;
	
	p++;
	*q = '\0';
	
	strcpy(ip, p);	//copy p,q,r,s,m,n

	for(i = 1; i <= 4 && (q = strchr(ip, ',')) != NULL; i++)
		*q = '.';			//replace 4 commas by .

	if(i != 5)
		return -1;
	
	*q = '\0';
	q++;
	
	strcpy(port1, q);
	q = strchr(port1, ',');

	if(q == NULL)
		return -1;
	
	*q = '\0';
	q++;
	
	strcpy(port2, q);


	port = strtoul(port1, NULL, 10) * 256;
	port += strtoul(port2, NULL, 10);

	if((dpd = socket(AF_INET, SOCK_STREAM, 0))<0) {
        Error("initPassive: Cannot crate socket\n");
        return -1;
    }

    memset(&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    inet_aton(ip, &addr.sin_addr);

    if(connect(dpd, (struct sockaddr*) &addr, sizeof(addr)) < 0) {
        Error("connectServer: Cannot connect %s",ip);
        return -1;
    }
    return dpd;
}


int Ftp(int client_sd, char *normUrl) {
	char buf[BUF_SIZE];
	char cmd[BUF_SIZE];
	char *pos;
	int ret, len;
	char server[STRING_SIZE], protocol[STRING_SIZE];
	char path[STRING_SIZE];
	char port[6];
	int portNo, netd, dpd;

	ParseURL(normUrl, protocol, server, port, path);	
	portNo = strtoul(port, NULL, 10);
	
	Trace("Connecting: %s:%d",server, portNo);
	
	if((netd = connectServer(server, portNo)) < 0) 
		return netd;

	pos = NULL;
	if(processResponse(netd, &ret, buf, pos, &len) != 1) {
		Error("connectFtp: error connecting(%d)", ret);
		buf[len] = 0;
		Trace("buf:%s", buf);
		return -1;
	}

	pos = NULL;
	sprintf(cmd, "USER %s\n", FTP_USER);
	if(send(netd, cmd, strlen(cmd), 0) == -1)
		return -1;

	if(processResponse(netd, &ret, buf, pos, &len) != 1) {
		if(ret != 3) {
			Trace("Error processing USER");
			return -1;			//error login
		}
		sprintf(cmd, "PASS %s\n", FTP_PASS);
		if(send(netd, cmd, strlen(cmd), 0) == -1)
			return -1;

		if(processResponse(netd, &ret, buf, pos, &len) != 1) {
			Error("Login failed");			
			return -1;
		}
	}
	
	pos = NULL;
	if(send(netd, "TYPE I\n", 7, 0) == -1)
		return -1;	
	if(processResponse(netd, &ret, buf, pos, &len) != 1)
		return -1;

	pos = NULL;
	if(send(netd, "PASV\n", 5, 0) == -1)
		return -1;	
	if(processResponse(netd, &ret, buf, pos, &len) != 1)
		return -1;	
	if((dpd = initPassive(buf, len)) < 0)
		return -1;
	
	pos = NULL;
	sprintf(cmd, "CWD %s\n", path);
	if(send(netd, cmd, strlen(cmd), 0) == -1)
		return -1;	
	if(processResponse(netd, &ret, buf, pos, &len) == 1)
		return listFtp(client_sd, netd, dpd, path);
	else if(ret != -1) 
		return getFtp(path, client_sd, netd, dpd);
	else		
		return -1;
}
