#include "main.h"

int GetandSend(int client_sd) {
	
	char comm[STRING_SIZE],url[STRING_SIZE],opt[STRING_SIZE];
	char line[STRING_SIZE];
	char proxyAuth[STRING_SIZE];
	char *buf, *normUrl;
	char *postbuf;
	register char *p, *q, *r;
	int len, header_end, force_flag = 0, proxy_auth = 0;
	unsigned totLen, i = 0;

	buf = NULL;
	totLen = 0;
	do {
		i++;
		if((buf = (char *)realloc(buf, BUF_SIZE*i*sizeof(char)+1)) == NULL) {
				Error("Not enough memory");
				return 0;
		}
		if((len = read(client_sd, buf+BUF_SIZE*(i-1), BUF_SIZE)) < 0) {
			Error("GetandSend: Read Error");
			return 0;
		}
		totLen += len;
	} while(len == BUF_SIZE);
		
	buf[totLen] = 0;
	
	p = buf;
	q = line;

	// Cut 1st Line to line
	while(*p && isspace(*p))
		p++;

	while(*p && *p!='\r' && *p!='\n')
		*q++ = *p++;
	*q = 0;
	if(*p == '\r') p++;
	if(*p == '\n') p++; //move to next line
	r = p;

	
	//Cut Command
	q = comm;
	p = line;
	while(*p && !isspace(*p))
		*q++ = *p++;
	*q = '\0';
	p++;	//skip space after comm
	
	q = url;	
	//copy url
	while(*p && !isspace(*p))
		*q++ = *p++;
	*q = 0;
	
	if(*p) 
		p++;
	
	opt[0] = 0;
	if(*p && *p != '\n' && *p != '\r')
		strcpy(opt, p);

	p = r;
	if(opt[0]) {		//if opt, HTTP/1.x exists
		header_end = 0;
		proxyAuth[0] = 0;

		while(1) {
			//check for header end

			if(*p == '\0' || *p == '\r' || *p == '\n') {
				header_end = 1;
				break;
			}
			
			//check for Pragma: no-cache
			if(!strncasecmp(p, "pragma:", 7)) {
				p += 7;
				while(*p && (*p == ' ' || *p == '\t'))
					p++;
				if(!strncasecmp(p, "no-cache", 8))
					force_flag = 1;
			}			
			//check for Authorization line
			else if(!strncasecmp(p, "Authorization:", 14)) {
				/*p += 14;
				while(*p && (*p == ' ' || *p == '\t'))
					p++;
*/
				q = Authorization_Line;
				while(*p && *p != '\r' && *p != '\n')
					*q++ = *p++;
				*q = 0;
				strcat(Authorization_Line, "\r\n");
			}
			else if(!strncasecmp(p, "Proxy-Authorization:", 20)) {
				p += 20;
				
				while(*p && (*p == ' ' || *p == '\t'))
					p++;
				if(!strncasecmp(p, "Basic", 5)) {
					p += 5;
					while(*p && (*p == ' ' || *p == '\t'))
						p++;
					
					proxy_auth = 1;
					q = proxyAuth;
					while(*p && !isspace(*p))
						*q++ = *p++;
					*q = 0;
				}
			}
			
			while(*p && *p != '\r' && *p != '\n')
					p++;

			if(*p == '\r') p++;
			if(*p == '\n') p++;				
		}	//next line while(1)
	}//if (opt)

	Log("Request:%s %s", comm, url);
	Trace("Request:%s %s", comm, url);
	if(force_flag) {
		Trace("Requested force reget");
		Log("Requested force reget");
	}		
	
	if(userTableLast && (!proxy_auth || !authenticate(proxyAuth))) {
		HTTP_Error(client_sd, 407, "Proxy Authentication Required\r\n" \
			"Proxy-Authenticate: Basic realm = \"Login for LinProxy\"", "" );
		Trace("Proxy-Authentication Failed");
		Log("Proxy-Authentication Failed");
		return 1;
	}
	
	normUrl = NormalizeURL(url);		
	if(!strncmp(normUrl, "http", 4)) {
		if(!strcmp(comm, "POST")) { //comm is post
			if(*p && *p == '\r') p++;
			if(*p && *p == '\n') p++;
		
			len = totLen - (p - buf);
			if((postbuf = (char *) malloc(len*sizeof(char))) 
							== NULL) {
				Error("Not Enough Memory");
				return 0;
			}		
			memcpy(postbuf, p, len);		
			Post_HTTP(client_sd, normUrl, postbuf, len);		
		}
		else if(!strcmp(comm, "GET")) {
			if(!force_flag && Have(normUrl) 
						   && Send_Page_From_Cache(normUrl, client_sd)) 
				Log("URL sent from Cache");
			else {	
				Log("URL not in Cache");
				if(Get_Http(client_sd, normUrl) != 0)
					HTTP_Error(client_sd, 404, "Not Found", 
									"Requested URL not found");
			}
		}
		else if(!strcmp(comm, "HEAD"))
			Head_Http(client_sd, normUrl);			
		else 
			HTTP_Error(client_sd, 501, "Not Implemented", 
							"Method not implementeed");
	}
	else if(!strncmp(normUrl, "ftp", 3) && !strcmp(comm, "GET")) {
		if(Ftp(client_sd, normUrl) != 1)
			HTTP_Error(client_sd, 404, "Not Found", 
							"Requested URL not found");
	}
	else 
			HTTP_Error(client_sd, 501, "Not Implemented", 
							"Method not implementeed");
}
