#include "main.h"

int Get_Http(int client_sd, char *full_norm_url)
{
    char protocol[STRING_SIZE],domname[STRING_SIZE],path[STRING_SIZE];
    char port[STRING_SIZE];
    time_t *start,*stop;
    char *fname, *tmp_name,*big_head;
    Info *info;
    int info_fd;
    int head_fd;
    int body_fd, sock_fd;
    int rcount, rtime, pos, hsum, bsum;
    char *head, buf[BUF_SIZE];
    int in_head,port_no;
    int server_status;
    char *temp;
    int secret_flag,cache_flag=0;
    int head_count=1,bodylength=0;  
    double timeto_download,expiry_time;
    time_t t1,t2; 
    struct tm expiry_date={0,0,0,0,0,0,0,0,-1}, last_mod_date={0,0,0,0,0,0,0,0,-1}, now_date={0,0,0,0,0,0,0,0,-1};
    unsigned int bodysize=0;
    
	start = (time_t *)malloc(sizeof(time_t));
	stop = (time_t *)malloc(sizeof(time_t));



	
	head=(char *)malloc(sizeof(char)*(BUF_SIZE+2));
    ParseURL(full_norm_url,protocol,domname,port,path);
    port_no=atoi(port);
    if( port_no==-1 ) {
        port_no = HTTPPORT;
    }
    if( Authorization_Line[0] ) {
	secret_flag = 1;   //doubt
    }
    else {
	secret_flag = 0;   //doubt
    }

    //Trace("HTTP_get: HTTP %c Server=%s Port=%d Path=%s. Authorization=%s\n",
 //  	secret_flag ? 'S' : '-', domname, port_no, path, Authorization_Line);
      
    
    /*
     * Send Request to Server
     */
    sprintf(buf,
    "GET %s HTTP/1.0\r\nUser-Agent: %s\r\nAccept: */*\r\n%s\r\n",
	path, AGENT_INFO, Authorization_Line);
     
    time(start);    //starting time

     if((sock_fd=connectServer(domname,port_no))<0)
     {
         Error(" Cannot connect to server %s at port %d\n",domname,port_no);
         return -1;	 
     }

    rcount=write(sock_fd,buf,strlen(buf));
    shutdown(sock_fd,1);

    memset(head,0,sizeof(char)*(BUF_SIZE+2));    //WHY +2?
    rtime=0;
    in_head=1;
    bsum=0;
    hsum=0;
    pos=0;
    
    while(in_head && (rcount=read(sock_fd,&head[pos],BUF_SIZE)))
    {
//       Trace("Rcount is %s",head);
       rcount+= pos;
       head_count++;
      if(rtime==0 && !strncmp(head,"HTTP/1.",7))
        { 
	    server_status= atoi(&head[9]);
//            Trace("Get_http server reply status is %d\n",server_status);
		if(server_status==401)
	    {
	      Trace("Authorization request");
	    }
	    else if(server_status<200 || server_status>400)
	    {
	       Error("Get_http error: Ignore reply status %d and Reject!",server_status);
              return server_status;
            }
       }

      while(pos <= rcount && !(head[pos]=='\n' && head[pos+1]=='\n') &&
		   !(head[pos]=='\n' && head[pos+1]=='\r' && head[pos+2]=='\n'))         pos++;       // consider this later
//      Trace("Get_http: Head %d bytes in %d bytes\n",pos,rcount);
      if(pos<=rcount) //this loop won't enter in the 1st attempt if Header comes                      //in 2 chunks of head
      {
	 if(head[pos+1]=='\r')
	    pos=pos+3;
         else
	    pos=pos+2;
		 
         temp= malloc(sizeof(char)*(pos+1));
         memcpy(temp,head,pos);
	 temp[pos]='\0';
        // Trace("Get_http: found separator at %d ( of %d bytes)\n",pos,rcount);
   	 write(client_sd,temp,pos);
         in_head=0;
//	 Trace("Body is %s",&head[pos]);
	 //write(client_sd,&head[pos],rcount-pos);
//	Trace("Head is \n%s ",temp);
	Parse_resp_header(temp,&expiry_date,&last_mod_date,&now_date,&bodysize);
//        Trace("From Parse :%d %d %d", expiry_date.tm_sec,last_mod_date.tm_sec,bodysize);        
	
	   if(!expiry_date.tm_mday && !last_mod_date.tm_mday)
	   { 
	       expiry_time= DEFAULT_EXP_TIME;
           }	
	   else if(!expiry_date.tm_mday && last_mod_date.tm_mday)
	   { 
		  
                 t1=mktime(&now_date);
		 t2=mktime(&last_mod_date);
		 expiry_time= LM_FACTOR * difftime(t1,t2);	
           }

	   else
	   {	   
	   t1=mktime(&expiry_date);
	   t2=mktime(&now_date);
	   expiry_time= difftime(t1,t2);
	   }
	if(Cachable(temp,expiry_time,now_date,bodysize,full_norm_url,secret_flag))
         {
	    
            cache_flag=1;
            fname= Convert_path(full_norm_url,HEAD_FILE);
	    if(Create_path(fname))
	    {	    
                  Error("Get_Http: Fail setup HEAD \"%s\".\n",fname);
                  free(fname);
                  return -1;
            }

           if((head_fd=open(fname,O_WRONLY|O_CREAT,0644))<0) 
	   {
             Error("Get_http: Cannot open HEAD file in pool\"%s\".\n",fname);
             free(fname);
             return -1;
           }
            free(fname);
    	    
    /*
     * Setup BODY file
     */

   	 fname = Convert_path(full_norm_url,BODY_FILE);
    	if(Create_path(fname))
	{
        	Error("Get_http: Fail setup BODY \"%s\".\n",fname);
        	free(fname);
        	return -1;
        }

        if((body_fd=open(fname,O_WRONLY|O_CREAT,0644))<0)
       	{
               Error("Get_http: Cannot open BODY file in pool\"%s\".\n",fname);
               free(fname);
              return -1;
        }
        free(fname);
        write(head_fd,head,pos);
        write(body_fd,&head[pos],rcount-pos);	
    }       //end of  if(cachable)
     // sprintf(buf,"this is the body, ha ha!\n Also the head looks like this %s\n",temp);
    memcpy(buf,&head[pos],rcount-pos);
      write(client_sd,buf,rcount-pos);
//      Trace("body is %s\n",buf);
      bsum=rcount-pos;
      bodylength=strlen(buf);
 head[pos]='\0';
// Trace("Get_http: Head %d Body %d in %d bytes and strlen is %d\n",pos,bsum,rcount,bodylength);
 }   //end of if(pos<=rcount) 

  else
  { 
     big_head= (char *)realloc((void *)head,sizeof(char)*head_count*BUF_SIZE);
     if(big_head!=NULL)
     {
        head=big_head;
     }
     else
     {
	 Error("Reallocate Error! \n");
     }
     bsum=0;
//     Trace("Get_http: Head %d bytes \n",rcount);
  }
  hsum+=pos;
  rtime++;

}    //end of while (in_head && ...)

if(cache_flag)
 {
     ftruncate(head_fd,hsum); //consider later

     close(head_fd);
 }
while(rcount=read(sock_fd,buf,BUF_SIZE))
 {
//    Trace("\nL Body is %s",buf);	 
    if(cache_flag)
     {
         if(write(body_fd,buf,rcount)!=rcount) 
            Error("Get_http: Cannot write reading %s\n",full_norm_url);
     }
	 write(client_sd,buf,rcount);
     
	 bsum += rcount;
	 if(bsum >= MAX_BODYSIZE) {
			cache_flag = 0;
			close(body_fd);
			fname = Convert_path(full_norm_url, HEAD_FILE);
			unlink(fname);
			free(fname);
			fname = Convert_path(full_norm_url, BODY_FILE);
			unlink(fname);
			free(fname);
	}
}

 shutdown(sock_fd, 2);
 close(sock_fd);
time(stop);
timeto_download=difftime(*stop,*start);

    /* Trace("--- START '%s'\r\n", path); */
    Trace("Get_http: [byte] HEAD %d, BODY %d, TOTAL %d",
		hsum, bsum, hsum+bsum);
    Trace("Get_http: Time taken to download the file[in seconds]  %f",
		timeto_download);

	if(bsum==0) {
        Error("Get_http: Empty data\n");
		return -1;
	}
        



    /*
     * Setup INFO file
     */
	Trace("Cache flag is %d",cache_flag);
    if(cache_flag)
    {	    
    fname = Convert_path(full_norm_url,INFO_FILE);
    if(Create_path(fname))
    {
        Error("Get_http: Fail setup INFO \"%s\".",fname);
        free(fname);
        return -1;
    }

    if((info_fd=open(fname,O_WRONLY|O_CREAT,0644))<0)
    {
        Error("Get_http: Cannot open INFO file in pool\"%s\".\n",fname);
        free(fname);
        return -1;
    }
    free(fname);
    if(bsum>bodysize)
     bodysize=bsum;
    info = (Info*)malloc(sizeof(Info));
    Generate_info(info,full_norm_url,bodysize,now_date,now_date,expiry_date,
		    last_mod_date,1,timeto_download);

    if((rcount=write(info_fd,info,sizeof(Info)))<sizeof(Info)) {
        Error("HTTP_get: Cannot write INFO.(%d/%d)\r\n"
            ,rcount,sizeof(Info));//can u write a struct to a struct to a file  like this

        return -1;
    }

    close(info_fd);
    }//if(cacheflag) 

    return 0;     // GET HTTP RETURNS 0 ON SUCCESS,-1 ON ERROR, STATUS CODE FOR
                   // ERROR MESSAGE IN THE HEADER
	
}

	  
void Parse_resp_header(char *head,struct tm *expiry_date,struct tm *last_mod_date,struct tm *now_date,unsigned int *bodysize)
{
  char lmdate[STRING_SIZE],expdate[STRING_SIZE],nowdate[STRING_SIZE];
  char body_size[STRING_SIZE];
  char *p,*q,*r,line[STRING_SIZE];
  int header_end=0;
  time_t tp;
  
  p=head;
  
  do{
           	 
      if((*p=='\n' && *(p+1)=='\n')||(*p=='\n' && *(p+1)=='\r' && *(p+2)=='\n'))      {
       header_end=1;
       break;
      }
      else 
      if((*p=='\n' && *(p+1)!='\n')||(*p=='\n' && *(p+1)!='\r' && *(p+2)!='\n'))
	      p++;
      while(*p && (*p == ' ' || *p == '\t'))
	      p++;
      
      q=line;
      while(*p && *p!='\n' && *p!='\r')
	      *q++=*p++;
      *q='\0';
	  p++;
      r = p;
      if(!strncmp("Last-Modified:",line,14))
      {   
	     p = line; 
		 p+=14;
              Trace("Last Modified Date found!");
     	 while(*p==' ' || *p=='\t')
	      p++;
      	 while(*p!=',')
	      p++;
         if(*p)
	     p++;
         q=lmdate;
         while(*p && *p!='\n' && *p!='\r')
         {
	      *q++=*p++;
         }
         *q='\0';
 //        Trace("Last mod date in parse %s",lmdate);
	 Create_date_struct(lmdate,last_mod_date);
        
      }	 
		      
      if(!strncmp("Expires:",line,8))
      {   
	     p = line; 
	      p+=8;
              Trace("Expiry date found!");
     	 while(*p==' ' || *p=='\t')
	      p++;
      	 while(*p!=',')
	      p++;
         if(*p)
	      p++;
         q=expdate;
         while(*p && *p!='\n' && *p!='\r')
         {
	      *q++=*p++;
         }
         *q='\0';

	 
//         Trace("exp date in parse %s",expdate);
         Create_date_struct(expdate,expiry_date);
      }	 
		      

      if(!strncmp("Date:",line,5))
      {   
	     p = line; 
	      p+=5;
              Trace("Downloaded date found");
     	 while(*p==' ' || *p=='\t')
	      p++;
      	 while(*p!=',')
	      p++;
         if(*p)
	      p++;
         q=nowdate;
         while(*p && *p!='\n' && *p!='\r')
         {
	      *q++=*p++;
         }
         *q='\0';
//         Trace("download date in parse%s",nowdate);
	 if(nowdate[0])
         Create_date_struct(nowdate,now_date);
	 else
         {		  
 	 time(&tp);
	 now_date=(struct tm *)gmtime(&tp);
	 }
	 
      }	 
	
   if(!strncmp("Content-Length:",line,15))
   {
	     p = line; 
		p+=15; 
   
     	 while(*p==' ' || *p=='\t')
	      p++;
         if(*p)
	      p++;
         q=body_size;
	 
         while(*p && *p!='\n' && *p!='\r')
         {
	      *q++=*p++;
         }
         *q='\0';
        // Trace("body size in parse %s",body_size);
	 *bodysize=(unsigned int)atoi(body_size);
	}
	p = r;
  }while(!header_end);
  return;
  
}

void Create_date_struct(char *date, struct tm *date_st)
{
	static char *Month[]={"January","February","March","April","May","June","July",	"August","September","October","November","December"};
	char day[10], month[10],year[10],hour[10],minute[10],second[10];
        char *p=date,*q;
        int i;
		q=day;
           while(*p && (*p==' '|| *p=='\t'))
		   p++;
		while(*p && *p!=' ' &&  *p!='\t')
	    {
	       *q++=*p++;
        }
           *q='\0';
	   //Trace("%s\n","inside datestruct");
          date_st->tm_mday=atoi(day);
	  //Trace(" this is the date %d %s",date_st->tm_mday,day);
	 if(*p) p++;
	  q=month; 
	while(*p && *p!=' ' &&  *p!='\t')
	 {
	   *q++=*p++;
          }
	   *q='\0';
	   for(i=0;i<=11;i++)
          {
            if(!strncmp(month,Month[i],3))		  
	    {
		   date_st->tm_mon=i;
                    break;
	    }
	   }
	   if(*p)  p++;
	  q=year; 
	while(*p && *p!=' ' &&  *p!='\t')
	 {
	   *q++=*p++;
          }
           *q='\0';
          date_st->tm_year=atoi(year)-1900;
           if(*p) p++;
          q=hour;	   
	while(*p && (*p!=' ' && *p!='\t' ) && *p!=':')
	 {
	   *q++=*p++;
          }
           *q='\0';
          date_st->tm_hour=atoi(hour);
         if(*p) p++;
	 q=minute; 
	while(*p && (*p!=' ' && *p!='\t' ) && *p!=':')
	 {
	   *q++=*p++;
          }
           *q='\0';
          date_st->tm_min=atoi(minute);

	if(*p) p++;
	 q=second;
	  while(*p && (*p!=' ' && *p!='\t' ) && *p!=':')
	 {
	   *q++=*p++;
          }
           *q='\0';
          date_st->tm_sec=atoi(second);
 }



    int Generate_info(Info *info,char *norm_url,unsigned int bodysize,
		    struct tm now_date,struct tm last_access,
		    struct tm expiry_date,
		    struct tm last_mod_date,int count,double timeto_download)
    {       
	    time_t t1,t2;
	    if(info==NULL)
            return 1;
              	   
	   strcpy(info->name,norm_url);
	   info->file_size=bodysize;
	   info->created_time=mktime(&now_date);
	   info->last_access_time=mktime(&last_access);
	   if(!expiry_date.tm_mday && !last_mod_date.tm_mday)
	   { 
		   /*
		expiry_date =  now_date;
             		expiry_date.tm_mday=now_date.tm_mday + DEFAULT_EXP_TIME;
		t1=mktime(&now_date);
		t2=mktime(&expiry_date);  */
	       info->expiry_time= DEFAULT_EXP_TIME;
           }	
	   else if(!expiry_date.tm_mday && last_mod_date.tm_mday)
	   { 
		  
                 t1=mktime(&now_date);
		 t2=mktime(&last_mod_date);
		 info->expiry_time= LM_FACTOR * difftime(t1,t2);	
           }

	   else
	   {	   
	   t1=mktime(&expiry_date);
	   t2=mktime(&now_date);
	   info->expiry_time= difftime(t1,t2);
	   }
	
	   info->access_count=count;
	   info->timeto_download=timeto_download;
    }          


/* THIS IS THE INFO STRUCTURE
 *
 * typedef struct 
 * {
 *    char *name;
 *    unsigned long file_size;
 *    time_t created_time;
 *    time_t last_access_time;
 *    double expiry_time;
 *    unsigned int access_count;
 *    double timeto_download;
 *  }Info;
 *  */
