#include "main.h"

void Trace(const char *fmt, ...)
{
    va_list args;
    int trace_flag = 1;
	char str[BUF_SIZE];

    va_start(args,fmt); 
    if(trace_flag) {
		vsprintf(str, fmt, args);
        fprintf(stderr,"#%d: %s\n", conn_count, str);
        fflush(stderr);
    }

    va_end(args);
}


void Error(const char *fmt, ...)
{
    va_list args;
    char report[STRING_SIZE];

    va_start(args,fmt);

    vsprintf(report, fmt, args);
    fprintf(stderr, "#%d: ERROR: %s\n", conn_count, report);
    fflush(stderr);

    va_end(args);
}

void Log(const char *fmt, ...)
{
	va_list args;
	char report[STRING_SIZE];
	FILE *fp;

	va_start(args, fmt);

	fp = fopen(LOG_FILE, "a");
	vsprintf(report, fmt, args);
	fprintf(fp, "#%d: %s\n", conn_count, report);
	fclose(fp);
}

void HTTP_Error(int sd, int no, char *str, char *msg) {
	char buf[BUF_SIZE];
	char info[STRING_SIZE];
	time_t t;
	
	time(&t);
	sprintf(info, "<PRE><HR><I><B>Generated by %s -- %s", 
					AGENT_INFO, ctime(&t));	
	sprintf(buf, "HTTP/1.0 %d %s\r\nContent-Type: text/html\r\n" \
				 "Content-Length: %d\r\n\r\n<HTML><BODY>%s%s</BODY></HTML>",
				  no, str, strlen(msg)+strlen(info)+26, msg, info);
	send(sd, buf, strlen(buf), 0);

}
		
