#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<sys/stat.h>
#include<sys/time.h>
#include<netinet/in.h>
#include<netdb.h>			//gethostbyname
#include<string.h>
#include<ctype.h>

#include <errno.h>
#include <time.h>

/*#include <varargs.h>*/
#include <stdarg.h>

#include <sys/wait.h>
#include <sys/resource.h>
#include <sys/signal.h>
#include <rpc/des_crypt.h>
#include <crypt.h>

#define BACKLOG 		10
#define HTTPPORT 		8080
#define STRING_SIZE  	256
#define BUF_SIZE 		4096
#define INI_USER_OFF 	0L
#define CRYPT_SALT		"$1$........"

#define LOCK_EXT		",lock"
#define INFO_EXT		",info"
#define HEAD_EXT		",head"
#define BODY_EXT		""
#define LOCK_FILE		0X01
#define BODY_FILE		0X02
#define HEAD_FILE		0X03
#define INFO_FILE		0X04
#define ACCEPT_MAX		50


#define ACCEPT_FILE 		"./accept.cfg"
#define INI_FILE 			"./ini"
#define CACHE_DIR  			"/tmp/linproxy"
#define PADDING_NAME		"__noname__.html"
#define LOG_FILE			"./log"
#define FTP_USER 			"anonymous"
#define FTP_PASS 			"linProxy@linproxy.com"

#define AGENT_INFO		"LinProxy v1.23"
#define DEFAULT_PATH 	"/"
#define LM_FACTOR       (0.1)
#define DEFAULT_EXP_TIME (60*60*24*7)

struct user {
	char user[33];
	char userPass[35];
};

 typedef struct 
  {
     char name[STRING_SIZE];
     unsigned long file_size;
     time_t created_time;
     time_t last_access_time;
     double expiry_time;
     unsigned int access_count;
     double timeto_download;
   }Info;
 
typedef struct {
	unsigned long mask;
	unsigned long addr;
} acc_addr;

void Trace(const char *, ...);

void Error(const char *, ...);

int ParseURL(char *normUrl, char *proto, char *server, char *port, char *path);
char *NormalizeURL(char *);

void HTTP_Error(int sd, int no, char *str, char *msg);

void Create_date_struct(char *date, struct tm *date_st);

int connectServer(char *, unsigned int);

void Parse_resp_header(char *head,struct tm *expiry_date,struct tm *last_mod_date,struct tm *now_date,unsigned int *bodysize);
char *Convert_path(char *full_norm_url,int cmd);
int Create_path(char *);
extern int Get_Http(int client_sd, char *full_norm_url);

int adduser(const char *ini_file); 
int deleteUser(const char *ini_file);
int changePass(const char *ini_file); 
int IsAcceptable(struct sockaddr_in *client_addr);
void ReadAcceptTable(char *accept_file);
int authenticate(const char *userPass); 
extern int Cachable(char *header,double expiry_time,struct tm now_date,unsigned long bodysize,char *full_norm_url,int authorization);


extern int conn_count;
extern char Authorization_Line[];
extern unsigned long MAX_BODYSIZE;
extern char pool_dir[];
extern char key[];
extern struct user *userTable;
extern int userTableLast;
